## procps 1.12.2

=== Makefile ===
# Makefile for procps.  Chuck Blake.
# Portions of this are highly dependent upon features specific to GNU make

# shared lib versions
VERSION      =  1
SUBVERSION   =  12

PREFIX     =  #proc# prefix for program names
MAN1DIR    =  /usr/man/man1
MAN7DIR    =  /usr/man/man7
MAN8DIR    =  /usr/man/man8
BINDIR     =  /bin
SBINDIR    =  /sbin
USRBINDIR  =  /usr/bin
INSTALLBIN =  install --owner bin --group 0 --mode a=rx --strip
INSTALLMAN =  install --owner man --group 0 --mode a=r
ARCH       =  $(shell arch)

BPROG      =  ps #						-> BINDIR
UPROG      =  uptime tload free w top vmstat watch # sessreg -> USRBINDIR
SPROG      =  psupdate #					-> SBINDIR
MAN1       =  ps.1 uptime.1 tload.1 free.1 w.1 top.1 sessreg.1 watch.1
MAN7       =  ps_color.7 ps_fields.7
MAN8       =  psupdate.8 vmstat.8

SUBDIRS    =  skill psmisc xproc xcpustate # sub-packages to build/install

CC         =  gcc -pipe -O3 -fomit-frame-pointer #easy to command-line override
CFLAGS     =  -I. -Wall -Wunused -fwritable-strings $(PROC_OPTIONS)
SHARED     =  1# build/install both a static and ELF shared library
SHLIBDIR   =  /lib# where to install the shared library

# Compile-time Options for libproc, top, ps and w.
# -DPROC_COLOR        enables color support
# -DNEW_TIME_DEFAULT  makes the new time format the default one

PROC_OPTIONS = -DPROC_COLOR #-DNEW_TIME_DEFAULT


LDFLAGS    =  -Wl,-warn-common #	recommended for ELF systems
#LDFLAGS    =  -qmagic #		recommended for a.out systems
#LDFLAGS    =  -Xlinker -qmagic #	older a.out systems may need this
#LDFLAGS    =  -N #			still older a.out systems use this

LIBCURSES  =  -lncurses# watch is the only thing that needs this
#LIBCURSES  =  -lcurses -ltermcap# BSD Curses requires termcap
LIBTERMCAP =  -lncurses # if you dont't have termcap, use -lncurses
EXTRALIBS  =  # -lshadow

INPLACE_CF = -Wall -Wunused -fwritable-strings $(PROC_OPTIONS)
INPLACE_TGT = -lproc

ifeq ($(ARCH),alpha)
 EXTRALIBS += -lbfd -liberty
endif

ifeq ($(ARCH),sparc)
 EXTRALIBS += -lbfd -liberty
endif

W_SHOWFROM =  -DW_SHOWFROM# don't show remote host users are logged in from.

#----------------------------------------------------#
# End of user-configurable portion of the Makefile.  #
# You should not need to modify anything below this. #
#----------------------------------------------------#
BUILD = $(BPROG) $(UPROG) $(SPROG) $(SUBDIRS)

# BUILD LIBRARIES + PROGRAMS
all: $(BUILD)

inplace:
	make CFLAGS="$(INPLACE_CF)" LIB_TGT=$(INPLACE_TGT) all

# INSTALL PROGRAMS + DOCS
install: $(patsubst %,install_%,$(BUILD) $(MAN1) $(MAN8) $(MAN7))
ifeq ($(SHARED),1)
	install --owner 0 --group 0 --mode a=rx $(LIB_TGT) $(SHLIBDIR)
endif

# INSTALL LIBRARIES + HEADERS (OPTIONAL)
libinstall:
	$(MAKE) -C proc install $(LIBPROCPASS)

clean:
	$(RM) $(OBJ) $(BPROG) $(UPROG) $(SPROG) *~
	for i in proc $(SUBDIRS); do $(MAKE) -C $$i clean; done
	rm xproc/Makefile

distclean: clean
	for i in proc $(SUBDIRS); do $(MAKE) -C $$i clean; done
	$(MAKE) -C psmisc spotless
	$(RM) $(OBJ) $(BPROG) $(UPROG) $(SPROG) xproc/Makefile* xcpustate/Makefile* \
	      proc/signames.h proc/.depend do_install

checkout:
	$(CO) $(RCSFILES)
checkclean:
	$(RM) $(RCSFILES)
realclean: clean checkclean

#-----------------------------------------------------#
# End of user-callable make targets.                  #
# You should not need to read anything below this.    #
#-----------------------------------------------------#

.PHONY:	all install libinstall clean distclean checkout checkclean realclean
.PHONY: $(patsubst %,install_%, $(BPROG) $(UPROG) $(SPROG))
.PHONY: proc psmisc skill xproc xcpustate
.PHONY: $(patsubst %,build_%, proc psmisc skill xproc xcpustate)
.PHONY: $(patsubst %,install_%, proc psmisc skill xproc xcpustate)

LIBPROCPASS  =  SHARED=$(SHARED) SHLIBDIR=$(SHLIBDIR) VERSION=$(VERSION) SUBVERSION=$(SUBVERSION) PROC_COLOR="$(PROC_OPTIONS)" CC="$(CC)"

# libproc setup

ifeq ($(SHARED),1)
    LIB_TGT = proc/libproc.so.$(VERSION).$(SUBVERSION)
else
    LIB_TGT = proc/libproc.a
endif

$(LIB_TGT): $(wildcard proc/*.[ch])
	$(MAKE) -C proc `basename $(LIB_TGT)` $(LIBPROCPASS) all

# component package setup -- the pattern should be obvious: A build rule and
# unified executable+documentation install rule. (An extra makefile rule is
# needed for those packages which use Imake.)

psmisc:             build_psmisc
build_psmisc:		; $(MAKE) -C psmisc LIBCURSES=$(LIBCURSES)
install_psmisc:     psmisc		; $(MAKE) -C psmisc install

skill:              build_skill
build_skill:				; $(MAKE) -C skill
install_skill:      skill		; $(MAKE) -C skill install

xproc:              build_xproc
build_xproc:        xproc/Makefile	; $(MAKE) -C xproc
install_xproc:      xproc		; $(MAKE) -C xproc install
xproc/Makefile:     xproc/Imakefile	; cd xproc; xmkmf -a

xcpustate:          build_xcpustate
build_xcpustate:    xcpustate/Makefile	; $(MAKE) -C xcpustate
install_xcpustate:  xcpustate		; $(MAKE) -C xcpustate install
xcpustate/Makefile: xcpustate/Imakefile	; cd xcpustate; xmkmf -a

# executable dependencies

ps top w uptime tload free vmstat sessreg utmp psupdate : $(LIB_TGT)

# static pattern build/link rules:

%.o : %.c
	$(CC) $(CFLAGS) -c $^

top.o: top.c top.h
	$(CC) $(CFLAGS) -c $<

ps w uptime tload free vmstat sessreg utmp: % : %.o
	$(strip $(CC) $(LDFLAGS) -o $@ $< $(LIB_TGT) $(EXTRALIBS))

# special instances link rules (need extra libraries/objects)

psupdate:%: %.o aoutupdate.o elfupdate.o bfdupdate.o
	$(strip $(CC) $(SLDFLAGS) -o $@ $^ $(EXTRALIBS))

top:   % : %.o
	$(strip $(CC)  $(LDFLAGS) -o $@ $^ $(LIB_TGT) $(LIBTERMCAP) $(EXTRALIBS))

watch:	% : %.o
	$(strip $(CC) $(SLDFLAGS) -o $@ $< $(LIBCURSES) $(EXTRALIBS))

# special instances of compile rules (need extra defines)
w.o:	w.c
	$(strip $(CC) $(CFLAGS) $(W_SHOWFROM) -c $< $(EXTRALIBS))

sessreg.o:	sessreg.c
	$(strip $(CC) $(CFLAGS) -DSYSV -c $<)

# static pattern installation rules

$(patsubst %,install_%,$(BPROG)): install_%: %
	$(INSTALLBIN) $< $(BINDIR)/$(PREFIX)$<
$(patsubst %,install_%,$(UPROG)): install_%: %
	$(INSTALLBIN) $< $(USRBINDIR)/$(PREFIX)$<
$(patsubst %,install_%,$(SPROG)): install_%: %
	$(INSTALLBIN) $< $(SBINDIR)/$(PREFIX)$<
$(patsubst %,install_%,$(MAN1)) : install_%: %
	$(INSTALLMAN) $< $(MAN1DIR)/$(PREFIX)$<
$(patsubst %,install_%,$(MAN8)) : install_%: %
	$(INSTALLMAN) $< $(MAN8DIR)/$(PREFIX)$<
$(patsubst %,install_%,$(MAN7)) : install_%: %
	$(INSTALLMAN) $< $(MAN7DIR)/$(PREFIX)$<

# miscellaneous useful macros

VC_SUF   =  ,v
VC_PFX   =  RCS/
RCSFILES =  $(patsubst $(VC_PFX)%$(VC_SUF),%,$(wildcard $(VC_PFX)*$(VC_SUF)))
SRC      =  $(sort $(wildcard *.c) $(filter %.c,$(RCSFILES)))
OBJ      =  $(SRC:.c=.o)

=== proc/Makefile ===
# Auto-adaptive C library Makefile adapted for libproc, Chuck Blake.
# Assumptions are basically that all the .c files in the CWD are modules
# for the library and that all .h files are the interface to the library.

# PROJECT SPECIFIC MACROS
NAME       =  proc
#VERSION    =  1        #These are inherited 
#SUBVERSION =  02
#SHARED     =  #1#	if 1 then do shared libraries as well as static

# INSTALLATION OPTIONS
TOPDIR     = /usr
HDRDIR     = $(TOPDIR)/include/$(NAME)#	where to put .h files
LIBDIR     = $(TOPDIR)/lib#		where to put library files
SHLIBDIR   = /lib#			where to put shared library files
HDROWN     = -o root -g root #		owner of header files
LIBOWN     = -o root -g root #		owner of library files
INSTALL    = install

# COMPILATION OPTIONS
CC         =  gcc -O4 -fomit-frame-pointer#-ggdb # easy to command-line override
CFLAGS     =  -I.. -Wall -fwritable-strings $(PROC_COLOR)

# ----------------------------------------------------------------#
# The rest is the auto-magic section -- highly GNU make dependent #
# You should never need to edit this.                             #
# ----------------------------------------------------------------#

VC_SUF     =  ,v
VC_PFX     =  RCS/
RCSFILES   =  $(patsubst $(VC_PFX)%$(VC_SUF),%,$(wildcard $(VC_PFX)*$(VC_SUF)))

# We take the union of RCS files and other files in CWD so that new files do
# not need to alter this makefile.  'sort' removes duplicates.  This allows the
# convenience of compiling and testing new files before the initial check-in.

SRC        =  $(sort $(wildcard *.c) $(filter %.c,$(RCSFILES)))
HDR        =  $(sort $(wildcard *.h) $(filter %.h,$(RCSFILES)))

OBJ        =  $(SRC:.c=.o)
SOBJ       =  $(SRC:.c=.so)
SONAME     =  lib$(NAME).so.$(VERSION).$(SUBVERSION)

ifeq ($(SHARED),1)
all: lib$(NAME).a $(SONAME)
else
all: lib$(NAME).a
endif

lib$(NAME).a: $(OBJ)
	$(AR) rcs $@ $^

$(SONAME): $(SOBJ)
	gcc -Wl,-shared -Wl,-soname,$(SONAME) -o $@ $^
	strip --strip-unneeded $(SONAME)
	ln -sf $(SONAME) lib$(NAME).so

# AUTOMATIC DEPENDENCY GENERATION -- GCC AND GNUMAKE DEPENDENT

.depend:
	$(strip $(CC) $(CFLAGS) -MM -MG $(SRC) > .depend)
include .depend

# INSTALLATION

install: all
	if ! [ -d $(HDRDIR) ] ; then mkdir $(HDRDIR) ; fi
	$(INSTALL) $(HDROWN) $(HDR) $(TOPDIR)/include/$(NAME)
	$(INSTALL) $(LIBOWN) lib$(NAME).a $(LIBDIR)
ifeq ($(SHARED),1)
	$(INSTALL) $(LIBOWN) $(SONAME) $(SHLIBDIR)
	ln -sf $(SHLIBDIR)/$(SONAME) $(SHLIBDIR)/lib$(NAME).so
	ldconfig
endif

# VARIOUS SHORT CUT TARGETS
.PHONY:	all install dep clean distclean checkout checkclean

dep:	.depend

clean:
	$(RM) lib$(NAME).a lib$(NAME).so* *.o *.so

distclean:	clean
	$(RM) .depend *~ signames.h

checkout:
	$(CO) $(RCSFILES)

checkclean:
	$(RM) $(RCSFILES)

# CUSTOM c -> o rule so that command-line has minimal whitespace

%.o : %.c
	$(strip $(CC) $(CFLAGS) -c $<)

%.so : %.c
	$(strip $(CC) $(CFLAGS) -fPIC -c $< -o $@)

# PROJECT SPECIFIC DEPENDENCIES/BUILD RULES


version.o:	version.c version.h
	$(strip $(CC) $(CFLAGS) -DVERSION=\"$(VERSION)\" -DSUBVERSION=\"$(SUBVERSION)\" -c version.c)

version.so:	version.c version.h
	$(strip $(CC) $(CFLAGS) -fPIC -DVERSION=\"$(VERSION)\" -DSUBVERSION=\"$(SUBVERSION)\" -c version.c -o $@ )

signals.o signals.so: signames.h

signames.h ../proc/signames.h : /usr/include/signal.h
	/lib/cpp -dM </usr/include/signal.h |	\
	tr -s '\t ' '  ' | sort -n +2 | sed		\
	's:#define SIG\([A-Z]\+[0-9]*\) \([0-9]\+\) *\(\|/\*.*\)$$:{\
\2,"\1" },:p;d'  > signames.h

=== psmisc/Makefile ===
CC=cc
CFLAGS=-O -DPSMISC_VERSION=\"`cat VERSION`\" \
  -Wall -Wno-parentheses -Wwrite-strings -Wpointer-arith -g \
  # -Wcast-align -Wconversion -g
LDFLAGS=#-s -N #-Xlinker -qmagic
REAL_CPP=/lib/cpp
PROGS=killall pstree fuser
EBINDIR=/bin		# essential binaries
BINDIR=/usr/bin		# not so essential ones
MANDIR=/usr/man/man1	# all man pages

all:		$(PROGS)

signames.h:	/usr/include/signal.h
		$(REAL_CPP) -dM </usr/include/signal.h | \
		tr -s '\t ' '  ' | sort -n +2 | sed \
	's:#define SIG\([A-Z]\+[0-9]*\) \([0-9]\+\) *\(\|/\*.*\)$$:{\
\2,"\1" },:p;d' \
		  > signames.h

signals.o:	signals.h signals.c signames.h Makefile

fuser.o:	fuser.c comm.h signals.h Makefile VERSION
killall.o:	killall.c comm.h signals.h Makefile VERSION

fuser:		fuser.o signals.o
killall:	killall.o signals.o

pstree:		pstree.c comm.h Makefile VERSION
		$(CC) $(CFLAGS) $(LDFLAGS) -o pstree pstree.c $(LIBCURSES)

install:	$(PROGS)
		install -d -o 0 -g 0 -m 755 $(BINDIR)
		install -o 0 -g 0 -m 555 fuser $(EBINDIR)
		install -o 0 -g 0 -m 555 killall $(BINDIR)
		install -o 0 -g 0 -m 555 pstree $(BINDIR)
		install -d -o 0 -g 0 -m 755 $(MANDIR)
		install -o 0 -g 0 -m 444 fuser.1 $(MANDIR)
		install -o 0 -g 0 -m 444 killall.1 $(MANDIR)
		install -o 0 -g 0 -m 444 pstree.1 $(MANDIR)

install-pidof:
		@[ -x `echo $(BINDIR)`/killall ] || { \
		  echo "Need `echo $(BINDIR)`/killall to install pidof"; \
		  exit 1 }
		ln -sf killall `echo $(BINDIR)`/pidof
		install -o 0 -g 0 -m 444 pidof.1 $(MANDIR)

clean:
		rm -f *.o signames.h

spotless:	clean
		rm -f $(PROGS)

=== debian/changelog ===
procps (1.12.2) stable unstable; urgency=low

  * fixed meminfo handling again, as the fix wouldn't work on pre-2.1.x
    kernels. 
  * fixed free to use the meminfo routines from libproc.

 -- Helmut Geyer <Helmut.Geyer@iwr.uni-heidelberg.de>  Fri, 13 Jun 1997 22:42:14 +0200

procps (1.12.1) stable unstable; urgency=low

  * fixed several bugs
  * replaced utmp handling to support wrappers.
  * added /proc/meminfo support for 2.1.x kernels.

 -- Helmut Geyer <Helmut.Geyer@iwr.uni-heidelberg.de>  Tue, 10 Jun 1997 23:59:41 +0200

procps (1.11.6) frozen unstable; urgency=medium

  * psmisc 1.14 : new upstream version (mainly bugfixes)
  * added a lot of new serial device major numbers to the device lookup
    code. Somehow it seems there are new serial devices every other week.
  * fixed a bug in top: broken .toprc may cause a segmentation fault.

 -- Helmut Geyer <Helmut.Geyer@iwr.uni-heidelberg.de>  Sun, 4 May 1997 09:50:30 +0200

procps (1.11.5) frozen unstable; urgency=medium

  * minor changes to make it compile with libc6
  * fix top behaviour on machines having nonstandard NR_TASKS up to 4k
    tasks 

 -- Helmut Geyer <Helmut.Geyer@iwr.uni-heidelberg.de>  Fri, 18 Apr 1997 02:07:46 +0200

procps (1.11.4) unstable; urgency=medium

  * strip libproc.so from unneeded symbols (Bug# 8311)
  * fixed watch.1 example (Bug# 8169)
  * partly fixed fuser sigsegv core dump (Bug# 8004)
  * menu entries for xproc and procps (Bug# 8325)
  * divertions for xmem and xload. (Bug# 7565)
  
 -- Helmut Geyer <Helmut.Geyer@iwr.uni-heidelberg.de>  Sun, 13 Apr 1997 20:55:05 +0200

procps (1.11.3) unstable; urgency=low

  * fixed uptime again, minor Makefile changes

 -- Helmut Geyer <Helmut.Geyer@iwr.uni-heidelberg.de>  Fri, 21 Feb 1997 16:22:04 +0100

procps (1.11.2) unstable; urgency=medium

  * fixed typo in ps_fields.7 (Bug#5457)
  * fixed typo in debian/rules (Bug #5585)
  * fixed bug in w introduced in 1.11.1 (Bugs #5489, #5694, #5695, #5705).
  * added support for non-standard serial devices (long overdue - Bug
    #5771). 
  * fixed uptime option handling (Bug #6099).
  * fixed top problems with missing/corrupted utmp (Bug #5819).
  * fixed manpage problems (Bug #5936).

 -- Helmut Geyer <Helmut.Geyer@iwr.uni-heidelberg.de>  Wed, 19 Feb 1997 18:49:26 +0100

=== debian/control ===
Source: procps
Section: base
Priority: required
Maintainer: Helmut Geyer <Helmut.Geyer@iwr.uni-heidelberg.de>
Standards-Version: 2.1.2.2

Package: procps
Architecture: any
Replaces: watch
Provides: watch
Essential: yes
Depends: ${shlibs:Depends}
Conflicts: watch
Suggests: pscol
Description: The /proc file system utilities.
 This is an experimental release of the procps suite. A lot of features have
 been added since the 1.01(a) release:
 - support for both BSD and POSIX (SVR4) style command line options.
 - completely configurable display of information.
 - colour markup of processes exceeding limits or belonging to special users.
 Please take a look at /usr/doc/procps/NEWS, /usr/doc/procps/changelog.debian and
 the manpages for a concise list. This is how the next upstream release of
 procps may look (i.e. it will  look like this if there is not too much
 resistance). 
 This is, for now, a debian-only package which should not appear outside of
 master.debian.org.
 .
 These are utilities to browse the /proc filesystem, which is not a real file
 system but a way for the kernel to provide information about the status of
 entries in its process table. (e.g. running, stopped or "zombie")
 Both command line and full screen utilities are provided. Ncurses is needed
 for the full screen utilities.

Package: libproc-dev
Architecture: any
Section: devel
Priority: optional
Depends: libc-dev, ${shlibs:Depends} 
Description: library for accessing process information from /proc
 These are the header files, static library and manpages for 
 libproc. Some packages using libproc to access process information
 from /proc need these to compile.

Package: xproc
Architecture: any
Section: admin
Priority: optional
Depends: ${shlibs:Depends}
Description: some tools to display process information on X
 This package includes some X programs displaying load, memory use or
 cpu states.

=== debian/rules ===
#! /usr/bin/make -f
#
# Last updated: Tue Jan  9 13:12:15 EST 1996 by Fernando Alegre.
#                                               <alegre@mars.superlink.net>
# Major changes for new source format  Oct 5 1996 Helmut Geyer
#
# To make the binary distribution package, the ``Debianized'' source package
# and the context diff to the original package, type `./debian.rules dist'.
# Make sure that `debian.rules' is executable before the final distribution
# is made.
#
# Invoke each target with `./debian.rules <target>'.  All targets should be
# invoked with the package root as the current directory.
#
# The `binary' target must be run as root, as it needs to install files with
# specific ownerships.
# 
# In general it is better to use 'dpkg-buildpackage -tc' to build all 
# important targets
INSTDIR=install -m 755 -o root -g root -d
INSTFILE=install -m 644 -o root -g root
INSTPRG=install -m 755 -o root -g root -s
INSTEXE=install -m 755 -o root -g root


DOCS=NEWS TODO BUGS 
# The name of the package (for example, `emacs').
p = procps
# version number of the shared library
v=1.12

MAN1=ps.1 uptime.1 tload.1 free.1 w.1 top.1 watch.1 skill/skill.1 \
     psmisc/killall.1 psmisc/pstree.1 psmisc/fuser.1
MAN3=proc/libproc.3 proc/libproc_pw.3 proc/readproctab.3 proc/libproc_dev.3 \
     proc/openproc.3 proc/templ.3 proc/libproc_output.3 proc/readproc.3
MAN7=ps_color.7 ps_fields.7
MAN8=psupdate.8 vmstat.8

define checkdir
   test -f proc/readproc.h -a -f debian/rules
endef

build:
# Builds the binary package.
	$(checkdir)
	-make clean
	make
	touch build

clean:
# Undoes the effect of `make -f debian.rules build'.
	$(checkdir)
	-make distclean
	-rm -f build
	-rm -rf debian/tmp
	-rm -f debian/*~
	-rm -f debian/files*

binary-indep: checkroot build 
	$(checkdir)

binary-procps: checkroot build 
	-rm -rf debian/tmp
	$(INSTDIR) debian/tmp
	chmod g-s debian/tmp
	$(INSTDIR) debian/tmp/DEBIAN
	$(INSTDIR) debian/tmp/bin
	$(INSTDIR) debian/tmp/usr/bin
	$(INSTDIR) debian/tmp/sbin
	$(INSTDIR) debian/tmp/usr/man/man1
	$(INSTDIR) debian/tmp/usr/man/man7
	$(INSTDIR) debian/tmp/usr/man/man8
	$(INSTDIR) debian/tmp/usr/lib/menu
	$(INSTPRG) ps debian/tmp/bin/ps
	$(INSTPRG) uptime debian/tmp/usr/bin/uptime
	$(INSTPRG) tload debian/tmp/usr/bin/tload
	$(INSTPRG) free debian/tmp/usr/bin/free
	$(INSTPRG) w debian/tmp/usr/bin/w
	$(INSTPRG) top debian/tmp/usr/bin/top
	$(INSTPRG) vmstat debian/tmp/usr/bin/vmstat
	$(INSTPRG) watch debian/tmp/usr/bin/watch
	$(INSTPRG) psupdate debian/tmp/sbin/psupdate
	$(INSTPRG) skill/skill debian/tmp/usr/bin/skill
	(cd debian/tmp/usr/bin && ln -s skill snice)
	$(INSTPRG) psmisc/fuser debian/tmp/bin		
	$(INSTPRG) psmisc/killall debian/tmp/usr/bin		
	$(INSTPRG) psmisc/pstree debian/tmp/usr/bin		
	$(INSTDIR) debian/tmp/lib
	$(INSTEXE) proc/libproc.so.$(v) debian/tmp/lib/libproc.so.$(v)
	$(INSTFILE) $(MAN1) debian/tmp/usr/man/man1
	$(INSTFILE) $(MAN7) debian/tmp/usr/man/man7
	$(INSTFILE) $(MAN8) debian/tmp/usr/man/man8
	$(INSTDIR) debian/tmp/usr/doc/$(p)
	$(INSTFILE) debian/changelog debian/tmp/usr/doc/procps/changelog.Debian
	$(INSTFILE) $(DOCS) debian/tmp/usr/doc/procps/
	$(INSTFILE) debian/shlibs debian/tmp/DEBIAN/
	$(INSTEXE) debian/postinst debian/tmp/DEBIAN/
	$(INSTEXE) debian/postrm debian/tmp/DEBIAN/
	$(INSTFILE) debian/copyright debian/tmp/usr/doc/$(p)/copyright
	$(INSTFILE) debian/menu.procps debian/tmp/usr/lib/menu/procps
	-gzip -9vfr debian/tmp/usr/man
	-gzip -9vfr debian/tmp/usr/doc
	(cd debian/tmp/usr/man/man1 ; ln -s skill.1.gz snice.1.gz)
	unset LD_PRELOAD; dpkg-shlibdeps -Ldebian/shlibs.ignore top
	dpkg-gencontrol -pprocps
	dpkg --build debian/tmp ..

binary-libproc: checkroot build
	rm -rf debian/tmp
	$(INSTDIR) debian/tmp
	chmod g-s debian/tmp
	$(INSTDIR) debian/tmp/DEBIAN
	$(INSTDIR) debian/tmp/usr/lib
	$(INSTFILE) proc/libproc.a debian/tmp/usr/lib
	(cd debian/tmp/usr/lib && ln -sf /lib/libproc.so.$(v) libproc.so )
	$(INSTDIR) debian/tmp/usr/include/proc
	$(INSTFILE) proc/*.h debian/tmp/usr/include/proc
	$(INSTDIR) debian/tmp/usr/doc/libproc
	$(INSTFILE) debian/copyright debian/tmp/usr/doc/libproc/
	$(INSTDIR) debian/tmp/usr/man/man3
	$(INSTFILE) $(MAN3) debian/tmp/usr/man/man3
	-gzip -9vfr debian/tmp/usr/man
	-gzip -9vfr debian/tmp/usr/doc
	unset LD_PRELOAD; dpkg-shlibdeps ps
	dpkg-gencontrol -plibproc-dev
	dpkg --build debian/tmp ..

binary-xproc: checkroot build
	rm -rf debian/tmp
	$(INSTDIR) debian/tmp
	chmod g-s debian/tmp
	$(INSTDIR) debian/tmp/DEBIAN
	$(INSTDIR) debian/tmp/usr/lib/menu
	$(INSTFILE) debian/menu.xproc debian/tmp/usr/lib/menu/xproc
	$(INSTDIR) debian/tmp/usr/X11R6/bin
	$(INSTPRG) xproc/xload debian/tmp/usr/X11R6/bin
	(cd debian/tmp/usr/X11R6/bin && ln -s xload xmem && ln -s xload xidle )
	$(INSTPRG) xcpustate/xcpustate debian/tmp/usr/X11R6/bin
	$(INSTDIR) debian/tmp/usr/X11R6/lib/X11/app-defaults
	$(INSTFILE) xproc/XLoad.ad \
	            debian/tmp/usr/X11R6/lib/X11/app-defaults/XLoad
	$(INSTFILE) xproc/XIdle.ad \
	            debian/tmp/usr/X11R6/lib/X11/app-defaults/XIdle
	$(INSTFILE) xproc/XMem.ad \
	            debian/tmp/usr/X11R6/lib/X11/app-defaults/XMem
	$(INSTDIR) debian/tmp/usr/X11R6/man/man1
	$(INSTFILE) xproc/xload.man debian/tmp/usr/X11R6/man/man1/xload.1x
	$(INSTFILE) xproc/xidle.man debian/tmp/usr/X11R6/man/man1/xidle.1x
	$(INSTFILE) xproc/xmem.man debian/tmp/usr/X11R6/man/man1/xmem.1x
	$(INSTFILE) xcpustate/xcpustate.man \
	            debian/tmp/usr/X11R6/man/man1/xcpustate.1x
	$(INSTDIR) debian/tmp/usr/doc/xproc
	$(INSTFILE) debian/copyright debian/tmp/usr/doc/xproc/copyright
	-gzip -9vfr debian/tmp/usr/X11R6/man
	-gzip -9vfr debian/tmp/usr/doc
	$(INSTEXE) debian/postrm.xproc debian/tmp/DEBIAN/postrm
	$(INSTEXE) debian/postinst.xproc debian/tmp/DEBIAN/postrm
	unset LD_PRELOAD; dpkg-shlibdeps xproc/xload
	dpkg-gencontrol -pxproc
	dpkg --build debian/tmp ..

# generic targets:
binary:     binary-indep binary-arch

binary-arch: binary-procps binary-libproc binary-xproc

source diff:
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

checkroot:
	$(checkdir)
	test root = "`whoami`"

.PHONY: binary binary-arch binary-indep clean checkroot binary-procps binary-libproc binary-xproc

## procps 2.0.6

=== Makefile ===
# Makefile for procps.  Chuck Blake.
# Portions of this are highly dependent upon features specific to GNU make

PREFIX     =  #proc# prefix for program names

DESTDIR = /
MAN1DIR    =  ${DESTDIR}/usr/man/man1
MAN8DIR    =  ${DESTDIR}/usr/man/man8
BINDIR     =  ${DESTDIR}/bin
SBINDIR    =  ${DESTDIR}/sbin
XBINDIR    =  ${DESTDIR}/usr/X11R6/bin
USRBINDIR  =  ${DESTDIR}/usr/bin
INSTALLBIN =  install --mode a=rx --strip
INSTALLSCT =  install --mode a=rx
INSTALLMAN =  install --mode a=r

BPROG      =  kill #					-> BINDIR
UPROG      =  oldps uptime tload free w top vmstat watch skill snice # -> USRBINDIR
SPROG      =  sysctl
MAN1       =  oldps.1 uptime.1 tload.1 free.1 w.1 top.1 watch.1 skill.1 kill.1 snice.1
MAN8       =  vmstat.8 sysctl.8
XSCPT      =  XConsole # -> XBINDIR

SUBDIRS    =  ps # sub-packages to build/install

# easy to command-line override
INCDIRS    =  -I/usr/include/ncurses -I/usr/X11R6/include

CC         =  gcc -O3 $(INCDIRS) -D_GNU_SOURCE#-ggdb
CFLAGS     =  -I. -W -Wall -Wstrict-prototypes -Wshadow -Wcast-align # -Wno-unused

OPT        =  -O3
CC         =  gcc #-ggdb
CFLAGS     =  -D_GNU_SOURCE $(OPT) -I. $(INCDIRS) -W -Wall -Wstrict-prototypes -Wshadow -Wcast-align # -Wno-unused

SHARED     =  1# build/install both a static and ELF shared library
SHLIBDIR   =  ${DESTDIR}/lib# where to install the shared library

LDFLAGS    =  -Wl,-warn-common #-s	recommended for ELF systems
#LDFLAGS    =  -qmagic -s#		recommended for a.out systems
#LDFLAGS    =  -Xlinker -qmagic -s#	older a.out systems may need this
#LDFLAGS    =  -N -s#			still older a.out systems use this

#BFD_CAPABLE = -DBFD_CAPABLE
#AOUT_CAPABLE = #-DAOUT_CAPABLE 
#ELF_CAPABLE = #-DELF_CAPABLE

#LIBBFD = -lbfd -liberty
LIBCURSES  =  -lncurses# watch is the only thing that needs this
#LIBCURSES  =  -lcurses -ltermcap# BSD Curses requires termcap
LIBTERMCAP =  -lncurses# provides perfectly good termcap support
#LIBTERMCAP =  -ltermcap
EXTRALIBS  =  # -lshadow

W_SHOWFROM =  -DW_SHOWFROM# show remote host users are logged in from.

#----------------------------------------------------#
# End of user-configurable portion of the Makefile.  #
# You should not need to modify anything below this. #
#----------------------------------------------------#
BUILD = $(BPROG) $(UPROG) $(SPROG) $(SUBDIRS)

# BUILD LIBRARIES + PROGRAMS
all: $(BUILD)

# INSTALL PROGRAMS + DOCS
install: $(patsubst %,install_%,$(BUILD) $(MAN1) $(MAN8))
ifeq ($(SHARED),1)
	install --owner 0 --group 0 --mode a=rx $(LIB_TGT) $(SHLIBDIR)
endif

# INSTALL LIBRARIES + HEADERS (OPTIONAL)
libinstall:
	$(MAKE) -C proc install $(LIBPROCPASS)

clean:
	$(RM) -f $(OBJ) $(BPROG) $(UPROG) $(SPROG)
	for i in proc $(SUBDIRS); do $(MAKE) -C $$i clean; done

distclean: clean
	for i in proc $(SUBDIRS); do $(MAKE) -C $$i clean; done
	$(RM) -f $(OBJ) $(BPROG) $(UPROG) $(SPROG) \
	      proc/.depend


#-----------------------------------------------------#
# End of user-callable make targets.                  #
# You should not need to read anything below this.    #
#-----------------------------------------------------#

.PHONY:	all install libinstall clean distclean
.PHONY: $(patsubst %,install_%, $(BPROG) $(UPROG) $(SPROG))
.PHONY: proc ps
.PHONY: $(patsubst %,build_%, proc ps)
.PHONY: $(patsubst %,install_%, proc ps)

VERSION      = $(shell awk '/^%define major_version/ { print $$3 }' < procps.spec)
SUBVERSION   = $(shell awk '/^%define minor_version/ { print $$3 }' < procps.spec)
MINORVERSION = $(shell awk '/^%define revision/ { print $$3 }' < procps.spec)

# Note: LIBVERSION may be less than $(VERSION).$(SUBVERSION).$(MINORVERSION)
# LIBVERSION is only set to current $(VERSION).$(SUBVERSION).$(MINORVERSION)
# when an incompatible change is made in libproc.
LIBVERSION   =  2.0.6
ifdef MINORVERSION
LIBPROCPASS  =  SHARED=$(SHARED) SHLIBDIR=$(SHLIBDIR) VERSION=$(VERSION) SUBVERSION=$(SUBVERSION) MINORVERSION=$(MINORVERSION) LIBVERSION=$(LIBVERSION)
else
LIBPROCPASS  =  SHARED=$(SHARED) SHLIBDIR=$(SHLIBDIR) VERSION=$(VERSION) SUBVERSION=$(SUBVERSION) LIBVERSION=$(LIBVERSION)
endif

# libproc setup

ifeq ($(SHARED),1)
    LIB_TGT = proc/libproc.so.$(LIBVERSION)
else
    LIB_TGT = proc/libproc.a
endif

$(LIB_TGT): $(wildcard proc/*.[ch])
	$(MAKE) -C proc `basename $(LIB_TGT)` $(LIBPROCPASS)

# component package setup -- the pattern should be obvious: A build rule and
# unified executable+documentation install rule. (An extra makefile rule is
# needed for those packages which use Imake.)

ps:              build_ps
build_ps:				; $(MAKE) -C ps
install_ps:      ps		; $(MAKE) -C ps install

# executable dependencies
oldps kill skill snice top w uptime tload free vmstat utmp : $(LIB_TGT)

# static pattern build/link rules:

%.o : %.c
	$(strip $(CC) $(CFLAGS) -c $^)

oldps w uptime tload free vmstat utmp: % : %.o
	$(strip $(CC) $(LDFLAGS) -o $@ $< $(LIB_TGT) $(EXTRALIBS))


# special instances of link rules (need extra libraries/objects)

top:   % : %.o
	$(strip $(CC)  $(LDFLAGS) -o $@ $^ $(LIB_TGT) $(LIBTERMCAP) $(EXTRALIBS))

watch:	% : %.o
	$(strip $(CC) $(SLDFLAGS) -o $@ $< $(LIBCURSES) $(EXTRALIBS))


# special instances of compile rules (need extra defines)
w.o:	w.c
	$(strip $(CC) $(CFLAGS) $(W_SHOWFROM) -c $<)

top.o:	top.c
	$(strip $(CC) $(CFLAGS) -fwritable-strings -c $<)

skill.o:	skill.c
	$(strip $(CC) $(CFLAGS) -DSYSV -c $<)

snice:	skill
	ln -f skill snice

kill:	skill
	ln -f skill kill


# static pattern installation rules

$(patsubst %,install_%,$(BPROG)): install_%: %
	$(INSTALLBIN) $< $(BINDIR)/$(PREFIX)$<
$(patsubst %,install_%,$(SPROG)): install_%: %
	$(INSTALLBIN) $< $(SBINDIR)/$(PREFIX)$<
$(patsubst %,install_%,$(UPROG)): install_%: %
	$(INSTALLBIN) $< $(USRBINDIR)/$(PREFIX)$<
$(patsubst %,install_%,$(XSCPT)): install_%: %
	$(INSTALLSCT) $< $(XBINDIR)/$(PREFIX)$<
$(patsubst %,install_%,$(MAN1)) : install_%: %
	$(INSTALLMAN) $< $(MAN1DIR)/$(PREFIX)$<
$(patsubst %,install_%,$(MAN8)) : install_%: %
	$(INSTALLMAN) $< $(MAN8DIR)/$(PREFIX)$<

# special case install rules
install_snice: snice install_skill
	cd $(USRBINDIR) && ln -f skill snice
install_kill: snice install_skill
	cd $(USRBINDIR) && ln -f skill kill

# Find all the source and object files in this directory

SRC      =  $(sort $(wildcard *.c))
OBJ      =  $(SRC:.c=.o)

CVSTAG = ps_$(VERSION)_$(SUBVERSION)_$(MINORVERSION)
FILEVERSION = $(VERSION).$(SUBVERSION).$(MINORVERSION)
dist: archive
archive:
	@cvs -Q tag -F $(CVSTAG)
	@rm -rf /tmp/procps
	@cd /tmp; cvs -Q -d $(CVSROOT) export -r$(CVSTAG) procps || echo GRRRrrrrr -- ignore [export aborted]
	@mv /tmp/procps /tmp/procps-$(FILEVERSION)
	@cd /tmp; tar czSpf procps-$(FILEVERSION).tar.gz procps-$(FILEVERSION)
	@cd /tmp; cp procps-$(FILEVERSION)/procps.lsm procps-$(FILEVERSION).lsm
	@rm -rf /tmp/procps-$(FILEVERSION)
	@echo "The final archive is /tmp/procps-$(FILEVERSION).tar.gz"

=== proc/Makefile ===
--- 
+++ 
@@ -4,9 +4,6 @@
 
 # PROJECT SPECIFIC MACROS
 NAME       =  proc
-#VERSION    =  1        #These are inherited 
-#SUBVERSION =  02
-#SHARED     =  #1#	if 1 then do shared libraries as well as static
 
 # INSTALLATION OPTIONS
 TOPDIR     = /usr
@@ -18,8 +15,9 @@
 INSTALL    = install
 
 # COMPILATION OPTIONS
-CC         =  gcc -O4 -fomit-frame-pointer#-ggdb # easy to command-line override
-CFLAGS     =  -I.. -Wall -fwritable-strings $(PROC_COLOR)
+CC         =  gcc -O2 -D_GNU_SOURCE #-ggdb # easy to command-line override
+#CC         =  gcc -pg -O2 -D_GNU_SOURCE -g3 # easy to command-line override
+CFLAGS     =  -I.. -W -Wall -Wstrict-prototypes -Wshadow -Wcast-align
 
 # ----------------------------------------------------------------#
 # The rest is the auto-magic section -- highly GNU make dependent #
@@ -38,10 +36,10 @@
 HDR        =  $(sort $(wildcard *.h) $(filter %.h,$(RCSFILES)))
 
 OBJ        =  $(SRC:.c=.o)
-SOBJ       =  $(SRC:.c=.so)
-SONAME     =  lib$(NAME).so.$(VERSION).$(SUBVERSION)
+SONAME     =  lib$(NAME).so.$(LIBVERSION)
 
 ifeq ($(SHARED),1)
+CFLAGS += -fpic
 all: lib$(NAME).a $(SONAME)
 else
 all: lib$(NAME).a
@@ -50,16 +48,15 @@
 lib$(NAME).a: $(OBJ)
 	$(AR) rcs $@ $^
 
-$(SONAME): $(SOBJ)
-	gcc -Wl,-shared -Wl,-soname,$(SONAME) -o $@ $^
-	strip --strip-unneeded $(SONAME)
+$(SONAME): $(OBJ)
+	gcc -shared -Wl,-soname,$(SONAME) -o $@ $^ -lc
 	ln -sf $(SONAME) lib$(NAME).so
 
 # AUTOMATIC DEPENDENCY GENERATION -- GCC AND GNUMAKE DEPENDENT
 
 .depend:
 	$(strip $(CC) $(CFLAGS) -MM -MG $(SRC) > .depend)
-include .depend
+-include .depend
 
 # INSTALLATION
 
@@ -69,7 +66,7 @@
 	$(INSTALL) $(LIBOWN) lib$(NAME).a $(LIBDIR)
 ifeq ($(SHARED),1)
 	$(INSTALL) $(LIBOWN) $(SONAME) $(SHLIBDIR)
-	ln -sf $(SHLIBDIR)/$(SONAME) $(SHLIBDIR)/lib$(NAME).so
+	cd $(SHLIBDIR) && ln -sf $(SONAME) lib$(NAME).so
 	ldconfig
 endif
 
@@ -79,10 +76,10 @@
 dep:	.depend
 
 clean:
-	$(RM) lib$(NAME).a lib$(NAME).so* *.o *.so
+	$(RM) lib$(NAME).* *.o DEADJOE
 
 distclean:	clean
-	$(RM) .depend *~ signames.h
+	$(RM) .depend *~
 
 checkout:
 	$(CO) $(RCSFILES)
@@ -95,23 +92,12 @@
 %.o : %.c
 	$(strip $(CC) $(CFLAGS) -c $<)
 
-%.so : %.c
-	$(strip $(CC) $(CFLAGS) -fPIC -c $< -o $@)
-
 # PROJECT SPECIFIC DEPENDENCIES/BUILD RULES
 
 
 version.o:	version.c version.h
+ifdef MINORVERSION
+	$(strip $(CC) $(CFLAGS) -DVERSION=\"$(VERSION)\" -DSUBVERSION=\"$(SUBVERSION)\" -DMINORVERSION=\"$(MINORVERSION)\" -c version.c)
+else
 	$(strip $(CC) $(CFLAGS) -DVERSION=\"$(VERSION)\" -DSUBVERSION=\"$(SUBVERSION)\" -c version.c)
-
-version.so:	version.c version.h
-	$(strip $(CC) $(CFLAGS) -fPIC -DVERSION=\"$(VERSION)\" -DSUBVERSION=\"$(SUBVERSION)\" -c version.c -o $@ )
-
-signals.o signals.so: signames.h
-
-signames.h ../proc/signames.h : /usr/include/signal.h
-	/lib/cpp -dM </usr/include/signal.h |	\
-	tr -s '\t ' '  ' | sort -n +2 | sed		\
-	's:#define SIG\([A-Z]\+[0-9]*\) \([0-9]\+\) *\(\|/\*.*\)$$:{\
-\2,"\1" },:p;d'  > signames.h
-
+endif

## procps 2.0.7

=== Makefile ===
--- 
+++ 
@@ -1,42 +1,47 @@
 # Makefile for procps.  Chuck Blake.
 # Portions of this are highly dependent upon features specific to GNU make
 
-PREFIX     =  #proc# prefix for program names
-
-DESTDIR = /
-MAN1DIR    =  ${DESTDIR}/usr/man/man1
-MAN8DIR    =  ${DESTDIR}/usr/man/man8
-BINDIR     =  ${DESTDIR}/bin
-SBINDIR    =  ${DESTDIR}/sbin
-XBINDIR    =  ${DESTDIR}/usr/X11R6/bin
-USRBINDIR  =  ${DESTDIR}/usr/bin
-INSTALLBIN =  install --mode a=rx --strip
-INSTALLSCT =  install --mode a=rx
-INSTALLMAN =  install --mode a=r
+export PREFIX     =  #proc# prefix for program names
+
+export DESTDIR    =  /
+export MANDIR     =  /usr/man
+export MAN1DIR    =  $(DESTDIR)$(MANDIR)/man1
+export MAN5DIR    =  $(DESTDIR)$(MANDIR)/man5
+export MAN8DIR    =  $(DESTDIR)$(MANDIR)/man8
+export BINDIR     =  $(DESTDIR)/bin
+export SBINDIR    =  $(DESTDIR)/sbin
+export XBINDIR    =  $(DESTDIR)/usr/X11R6/bin
+export USRBINDIR  =  $(DESTDIR)/usr/bin
+export PROCDIR    =  $(DESTDIR)/usr/bin# /usr/proc/bin for Solaris devotees
+export APPLNK     =  $(DESTDIR)/etc/X11/applnk/Utilities
+export OWNERGROUP =  --owner 0 --group 0
+export INSTALLBIN =  install --mode a=rx --strip
+export INSTALLSCT =  install --mode a=rx
+export INSTALLMAN =  install --mode a=r
 
 BPROG      =  kill #					-> BINDIR
 UPROG      =  oldps uptime tload free w top vmstat watch skill snice # -> USRBINDIR
+PPROG      =  pgrep pkill# -> PROCDIR
 SPROG      =  sysctl
-MAN1       =  oldps.1 uptime.1 tload.1 free.1 w.1 top.1 watch.1 skill.1 kill.1 snice.1
+MAN1       =  oldps.1 uptime.1 tload.1 free.1 w.1 top.1 watch.1 skill.1 kill.1 snice.1 pgrep.1 pkill.1
+MAN5       =  sysctl.conf.5
 MAN8       =  vmstat.8 sysctl.8
+DESKTOP    =  top.desktop
 XSCPT      =  XConsole # -> XBINDIR
 
 SUBDIRS    =  ps # sub-packages to build/install
 
 # easy to command-line override
-INCDIRS    =  -I/usr/include/ncurses -I/usr/X11R6/include
-
-CC         =  gcc -O3 $(INCDIRS) -D_GNU_SOURCE#-ggdb
-CFLAGS     =  -I. -W -Wall -Wstrict-prototypes -Wshadow -Wcast-align # -Wno-unused
-
-OPT        =  -O3
-CC         =  gcc #-ggdb
-CFLAGS     =  -D_GNU_SOURCE $(OPT) -I. $(INCDIRS) -W -Wall -Wstrict-prototypes -Wshadow -Wcast-align # -Wno-unused
-
-SHARED     =  1# build/install both a static and ELF shared library
-SHLIBDIR   =  ${DESTDIR}/lib# where to install the shared library
-
-LDFLAGS    =  -Wl,-warn-common #-s	recommended for ELF systems
+export INCDIRS    =  -I/usr/include/ncurses -I/usr/X11R6/include
+
+export CC         =  gcc #-ggdb # this gets compiling and linking :-)
+export OPT        =  -O2
+export CFLAGS     =  -D_GNU_SOURCE $(OPT) -I$(shell pwd) $(INCDIRS) -W -Wall -Wstrict-prototypes -Wshadow -Wcast-align -Wmissing-prototypes
+
+export SHARED     =  1# build/install both a static and ELF shared library
+export SHLIBDIR   =  $(DESTDIR)/lib# where to install the shared library
+
+export LDFLAGS    =  -Wl,-warn-common #-s	recommended for ELF systems
 #LDFLAGS    =  -qmagic -s#		recommended for a.out systems
 #LDFLAGS    =  -Xlinker -qmagic -s#	older a.out systems may need this
 #LDFLAGS    =  -N -s#			still older a.out systems use this
@@ -58,15 +63,15 @@
 # End of user-configurable portion of the Makefile.  #
 # You should not need to modify anything below this. #
 #----------------------------------------------------#
-BUILD = $(BPROG) $(UPROG) $(SPROG) $(SUBDIRS)
+BUILD = $(BPROG) $(UPROG) $(PPROG) $(SPROG) $(SUBDIRS) $(DESKTOP)
 
 # BUILD LIBRARIES + PROGRAMS
 all: $(BUILD)
 
 # INSTALL PROGRAMS + DOCS
-install: $(patsubst %,install_%,$(BUILD) $(MAN1) $(MAN8))
+install: $(patsubst %,install_%,$(BUILD) $(XSCPT) $(MAN1) $(MAN5) $(MAN8))
 ifeq ($(SHARED),1)
-	install --owner 0 --group 0 --mode a=rx $(LIB_TGT) $(SHLIBDIR)
+	install $(OWNERGROUP) --mode a=rx $(LIB_TGT) $(SHLIBDIR)
 endif
 
 # INSTALL LIBRARIES + HEADERS (OPTIONAL)
@@ -74,7 +79,7 @@
 	$(MAKE) -C proc install $(LIBPROCPASS)
 
 clean:
-	$(RM) -f $(OBJ) $(BPROG) $(UPROG) $(SPROG)
+	$(RM) -f $(OBJ) $(BPROG) $(UPROG) $(PPROG) $(SPROG)
 	for i in proc $(SUBDIRS); do $(MAKE) -C $$i clean; done
 
 distclean: clean
@@ -101,7 +106,7 @@
 # Note: LIBVERSION may be less than $(VERSION).$(SUBVERSION).$(MINORVERSION)
 # LIBVERSION is only set to current $(VERSION).$(SUBVERSION).$(MINORVERSION)
 # when an incompatible change is made in libproc.
-LIBVERSION   =  2.0.6
+LIBVERSION   =  2.0.7
 ifdef MINORVERSION
 LIBPROCPASS  =  SHARED=$(SHARED) SHLIBDIR=$(SHLIBDIR) VERSION=$(VERSION) SUBVERSION=$(SUBVERSION) MINORVERSION=$(MINORVERSION) LIBVERSION=$(LIBVERSION)
 else
@@ -135,7 +140,7 @@
 %.o : %.c
 	$(strip $(CC) $(CFLAGS) -c $^)
 
-oldps w uptime tload free vmstat utmp: % : %.o
+oldps w uptime tload free vmstat utmp pgrep: % : %.o
 	$(strip $(CC) $(LDFLAGS) -o $@ $< $(LIB_TGT) $(EXTRALIBS))
 
 
@@ -164,6 +169,8 @@
 kill:	skill
 	ln -f skill kill
 
+pkill:	pgrep
+	ln -f pgrep pkill
 
 # static pattern installation rules
 
@@ -173,18 +180,26 @@
 	$(INSTALLBIN) $< $(SBINDIR)/$(PREFIX)$<
 $(patsubst %,install_%,$(UPROG)): install_%: %
 	$(INSTALLBIN) $< $(USRBINDIR)/$(PREFIX)$<
+$(patsubst %,install_%,$(PPROG)): install_%: %
+	$(INSTALLBIN) $< $(PROCDIR)/$(PREFIX)$<
 $(patsubst %,install_%,$(XSCPT)): install_%: %
 	$(INSTALLSCT) $< $(XBINDIR)/$(PREFIX)$<
 $(patsubst %,install_%,$(MAN1)) : install_%: %
 	$(INSTALLMAN) $< $(MAN1DIR)/$(PREFIX)$<
+$(patsubst %,install_%,$(MAN5)) : install_%: %
+	$(INSTALLMAN) $< $(MAN5DIR)/$(PREFIX)$<
 $(patsubst %,install_%,$(MAN8)) : install_%: %
 	$(INSTALLMAN) $< $(MAN8DIR)/$(PREFIX)$<
+$(patsubst %,install_%,$(DESKTOP)) : install_%: %
+	$(INSTALLSCT $< $(APPLNK)/$(PREFIX)$<
 
 # special case install rules
 install_snice: snice install_skill
 	cd $(USRBINDIR) && ln -f skill snice
 install_kill: snice install_skill
 	cd $(USRBINDIR) && ln -f skill kill
+install_pkill: pgrep install_pgrep
+	cd $(USRBINDIR) && ln -f pgrep pkill
 
 # Find all the source and object files in this directory

## procps 3.2.7

=== Makefile ===
# procps Makefile
# Albert Cahalan, 2002-2004
#
# Recursive make is considered harmful:
# http://google.com/search?q=%22recursive+make+considered+harmful%22
#
# For now this Makefile uses explicit dependencies. The project
# hasn't grown big enough to need something complicated, and the
# dependency tracking files are an ugly annoyance.
#
# This file includes */module.mk files which add on to variables:
# FOO += bar/baz
#
#
# Set (or uncomment) SKIP if you wish to avoid something.
# For example, you may prefer the /bin/kill from util-linux or bsdutils.


VERSION      := 3
SUBVERSION   := 2
MINORVERSION := 7
TARVERSION   := $(VERSION).$(SUBVERSION).$(MINORVERSION)

############ vars

# so you can disable them or choose alternates
ldconfig := ldconfig
ln_f     := ln -f
ln_sf    := ln -sf
install  := install -D --owner 0 --group 0

# Lame x86-64 /lib64 and /usr/lib64 abomination:
lib64    := lib$(shell [ -d /lib64 ] && echo 64)

usr/bin                  := $(DESTDIR)/usr/bin/
bin                      := $(DESTDIR)/bin/
sbin                     := $(DESTDIR)/sbin/
usr/proc/bin             := $(DESTDIR)/usr/bin/
man1                     := $(DESTDIR)/usr/share/man/man1/
man5                     := $(DESTDIR)/usr/share/man/man5/
man8                     := $(DESTDIR)/usr/share/man/man8/
lib                      := $(DESTDIR)/$(lib64)/
usr/lib                  := $(DESTDIR)/usr/$(lib64)/
usr/include              := $(DESTDIR)/usr/include/

#SKIP     := $(bin)kill $(man1)kill.1

BINFILES := $(usr/bin)uptime $(usr/bin)tload $(usr/bin)free $(usr/bin)w \
            $(usr/bin)top $(usr/bin)vmstat $(usr/bin)watch $(usr/bin)skill \
            $(usr/bin)snice $(bin)kill $(sbin)sysctl $(usr/bin)pmap \
            $(usr/proc/bin)pgrep $(usr/proc/bin)pkill $(usr/bin)slabtop \
            $(usr/proc/bin)pwdx

MANFILES := $(man1)uptime.1 $(man1)tload.1 $(man1)free.1 $(man1)w.1 \
            $(man1)top.1 $(man1)watch.1 $(man1)skill.1 $(man1)kill.1 \
            $(man1)snice.1 $(man1)pgrep.1 $(man1)pkill.1 $(man1)pmap.1 \
            $(man5)sysctl.conf.5 $(man8)vmstat.8 $(man8)sysctl.8 \
            $(man1)slabtop.1 $(man1)pwdx.1

TARFILES := AUTHORS BUGS NEWS README TODO COPYING COPYING.LIB \
            Makefile procps.lsm procps.spec v t README.top CodingStyle \
            sysctl.conf minimal.c $(notdir $(MANFILES)) dummy.c \
            uptime.c tload.c free.c w.c top.c vmstat.c watch.c skill.c \
            sysctl.c pgrep.c top.h pmap.c slabtop.c pwdx.c

# Stuff (tests, temporary hacks, etc.) left out of the standard tarball
# plus the top-level Makefile to make it work stand-alone.
_TARFILES := Makefile

CURSES := -lncurses

# This seems about right for the dynamic library stuff.
# Something like this is probably needed to make the SE Linux
# library loading not conflict with embedded systems stuff.
#
#ifeq ($(SHARED),1)
#ldl := -ldl
#LIBTYPE := -DSHAREDLIB
#else
#LIBTYPE := -DSTATICLIB
#endif

# Preprocessor flags.
PKG_CPPFLAGS := -D_GNU_SOURCE -I proc
CPPFLAGS     := -I/usr/include/ncurses
ALL_CPPFLAGS := $(PKG_CPPFLAGS) $(CPPFLAGS)

# Left out -Wconversion due to noise in glibc headers.
# Left out -Wunreachable-code and -Wdisabled-optimization
# because gcc spews many useless warnings with them.
#
# Since none of the PKG_CFLAGS things are truly required
# to compile procps, they might best be moved to CFLAGS.
# On the other hand, they aren't normal -O -g things either.
#
# Note that -O2 includes -fomit-frame-pointer only if the arch
# doesn't lose some debugging ability.
#
PKG_CFLAGS   := -fno-common -ffast-math \
  -W -Wall -Wshadow -Wcast-align -Wredundant-decls \
  -Wbad-function-cast -Wcast-qual -Wwrite-strings -Waggregate-return \
  -Wstrict-prototypes -Wmissing-prototypes
# Note that some stuff below is conditional on CFLAGS containing
# an option that starts with "-g". (-g, -g2, -g3, -ggdb, etc.)
CFLAGS       := -O2 -s
ALL_CFLAGS   := $(PKG_CFLAGS) $(CFLAGS)

PKG_LDFLAGS  := -Wl,-warn-common
LDFLAGS      :=
ALL_LDFLAGS  := $(PKG_LDFLAGS) $(LDFLAGS)

############ Add some extra flags if gcc allows

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),tar)  
ifneq ($(MAKECMDGOALS),extratar)
ifneq ($(MAKECMDGOALS),beta)

# Unlike the kernel one, this check_gcc goes all the way to
# producing an executable. There might be a -m64 that works
# until you go looking for a 64-bit curses library.
check_gcc = $(shell if $(CC) $(ALL_CPPFLAGS) $(ALL_CFLAGS) dummy.c $(ALL_LDFLAGS) $(1) -o /dev/null $(CURSES) > /dev/null 2>&1; then echo "$(1)"; else echo "$(2)"; fi ;)

# Be 64-bit if at all possible. In a cross-compiling situation, one may
# do "make m64=-m32 lib64=lib" to produce 32-bit executables. DO NOT
# attempt to use a 32-bit executable on a 64-bit kernel. Packagers MUST
# produce separate executables for ppc and ppc64, s390 and s390x,
# i386 and x86-64, mips and mips64, sparc and sparc64, and so on.
# Failure to do so will cause data corruption.
m64 := $(call check_gcc,-m64,$(call check_gcc,-mabi=64,))
ALL_CFLAGS += $(m64)

ALL_CFLAGS += $(call check_gcc,-Wdeclaration-after-statement,)
ALL_CFLAGS += $(call check_gcc,-Wpadded,)
ALL_CFLAGS += $(call check_gcc,-Wstrict-aliasing,)

# Adding -fno-gcse might be good for those files which
# use computed goto.
#ALL_CFLAGS += $(call check_gcc,-fno-gcse,)

# if not debugging, enable things that could confuse gdb
ifeq (,$(findstring -g,$(filter -g%,$(CFLAGS))))
ALL_CFLAGS += $(call check_gcc,-fweb,)
ALL_CFLAGS += $(call check_gcc,-frename-registers,)
ALL_CFLAGS += $(call check_gcc,-fomit-frame-pointer,)
endif

# in case -O3 is enabled, avoid bloat
ALL_CFLAGS += $(call check_gcc,-fno-inline-functions,)

endif
endif
endif
endif

############ misc.

# free.c pmap.c sysctl.c uptime.c vmstat.c watch.c pgrep.c skill.c tload.c top.c w.c
# utmp.c oldtop.c tmp-junk.c minimal.c

.SUFFIXES:
.SUFFIXES: .a .o .c .s .h

.PHONY: all clean do_all install tar extratar beta

ALL := $(notdir $(BINFILES))

CLEAN := $(notdir $(BINFILES))

DIRS :=

INSTALL := $(BINFILES) $(MANFILES)

# want this rule first, use := on ALL, and ALL not filled in yet
all: do_all

-include */module.mk

do_all:    $(ALL)

junk := DEADJOE *~ *.o core gmon.out

# Remove $(junk) from all $(DIRS)
CLEAN += $(junk) $(foreach dir,$(DIRS),$(addprefix $(dir), $(junk)))

##########
# not maintained because it isn't really needed:
#
#SRC :=
#OBJ := $(patsubst %.c,%.o, $(filter %.c,$(SRC)))
#
#ifneq ($(MAKECMDGOALS),clean)
#-include $(OBJ:.o=.d)
#endif
#
#%.d: %.c
#	depend.sh $(ALL_CPPFLAGS) $(ALL_CFLAGS) $< > $@
############

# don't want to type "make procps-$(TARVERSION).tar.gz"
tar: $(TARFILES)
	mkdir procps-$(TARVERSION)
	(tar cf - $(TARFILES)) | (cd procps-$(TARVERSION) && tar xf -)
	tar cf procps-$(TARVERSION).tar procps-$(TARVERSION)
	gzip -9 procps-$(TARVERSION).tar

extratar: $(_TARFILES)
	mkdir procps-$(TARVERSION)
	(tar cf - $(_TARFILES)) | (cd procps-$(TARVERSION) && tar xf -)
	tar cf extra-$(TARVERSION).tar procps-$(TARVERSION)
	gzip -9 extra-$(TARVERSION).tar

beta: $(TARFILES) $(_TARFILES)
	mkdir beta-$(TARVERSION)
	(tar cf - $(TARFILES) $(_TARFILES)) | (cd beta-$(TARVERSION) && tar xf -)
	tar cf beta-$(TARVERSION).tar beta-$(TARVERSION)
	gzip -9 beta-$(TARVERSION).tar

clean:
	rm -f $(CLEAN)

###### install

$(BINFILES) : all
	$(install) --mode a=rx $(notdir $@) $@

$(MANFILES) : all
	$(install) --mode a=r $(notdir $@) $@

install: $(filter-out $(SKIP) $(addprefix $(DESTDIR),$(SKIP)),$(INSTALL))
	cd $(usr/bin) && $(ln_f) skill snice
	cd $(usr/proc/bin) && $(ln_f) pgrep pkill

############ prog.c --> prog.o

top.o : top.h

%.o : %.c
	$(CC) $(ALL_CPPFLAGS) $(ALL_CFLAGS) -c -o $@ $<

w.o:    w.c
	$(CC) $(ALL_CPPFLAGS) $(ALL_CFLAGS) $(W_SHOWFROM) -c $<

############ prog.o --> prog

pmap w uptime tload free sysctl vmstat utmp pgrep skill pwdx: % : %.o $(LIBPROC)
	$(CC) $(ALL_CFLAGS) $^ $(ALL_LDFLAGS) -o $@

slabtop top: % : %.o $(LIBPROC)
	$(CC) $(ALL_CFLAGS) $^ $(ALL_LDFLAGS) -o $@ $(CURSES)

watch: % : %.o
	$(CC) $(ALL_CFLAGS) $^ $(ALL_LDFLAGS) -o $@ $(CURSES)

############ progX --> progY

snice kill: skill
	$(ln_f) skill $@

pkill: pgrep
	$(ln_f) pgrep pkill
